Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 1200)
@@ -3757,5 +3562,5 @@
     numActiveRefLayerPics = 0; 
   }
-#if H_3D
+#if NH_3D
   else if( getVPS()->getMaxOneActiveRefLayerFlag() || getVPS()->getNumRefListLayers( getLayerId() ) == 1 )
 #else
@@ -3772,7 +3577,7 @@
 }
 
-Int TComSlice::getRefPicLayerId( Int i )
-{
-#if H_3D
+Int TComSlice::getRefPicLayerId( Int i ) const
+{
+#if NH_3D
   return getVPS()->getIdRefListLayer( getLayerId(), getInterLayerPredLayerIdc( i ) );
 #else
@@ -3861,5 +3666,5 @@
         TComPic* picV = getIvPic( getIsDepth(), getVPS()->getViewIndex( layerIdInNuh ) );
         assert( picV != NULL ); 
-        std::vector<Int> pocsInCurrRPSsPicV = picV->getSlice(0)->getPocsInCurrRPSs(); 
+        IntAry1d pocsInCurrRPSsPicV = picV->getSlice(0)->getPocsInCurrRPSs(); 
         Bool refRpRefAvailFlag = false; 
         for (Int idx = 0; idx < pocsInCurrRPSsPicV.size(); idx++)
@@ -4025,5 +3830,5 @@
 }
 #endif
-#if H_3D
+#if NH_3D
 Void TComSlice::setIvPicLists( TComPicLists* m_ivPicLists )
 {
@@ -4050,7 +3855,10 @@
 #endif
 
+  Int bitDepthY = getSPS()->getBitDepth(CHANNEL_TYPE_LUMA);
 
   if( !setupLUT )
+  {
     return; 
+  }
 
   m_numViews = getVPS()->getNumViews(); 
@@ -4061,5 +3869,5 @@
     for ( Int i = 0; i < getVPS()->getNumViews(); i++ )
     {
-      m_depthToDisparityB[ i ] = new Int[ Int(1 << g_bitDepthY) ]; 
+      m_depthToDisparityB[ i ] = new Int[ Int(1 << bitDepthY) ]; 
     }
   }
@@ -4071,5 +3879,5 @@
     for ( Int i = 0; i < m_numViews; i++ )
     {
-      m_depthToDisparityF[ i ] = new Int[ Int(1 << g_bitDepthY) ]; 
+      m_depthToDisparityF[ i ] = new Int[ Int(1 << bitDepthY) ]; 
     }
   }
@@ -4078,14 +3886,14 @@
   assert( m_depthToDisparityF != NULL ); 
 
-  TComVPS* vps = getVPS(); 
-
-  Int log2Div = g_bitDepthY - 1 + vps->getCpPrecision();
+  const TComVPS* vps = getVPS(); 
+
+  Int log2Div = bitDepthY - 1 + vps->getCpPrecision();
   Int voiInVps = vps->getVoiInVps( getViewIndex() ); 
   Bool camParaSH = vps->getCpInSliceSegmentHeaderFlag( voiInVps );  
 
-  Int* codScale     = camParaSH ? m_aaiCodedScale [ 0 ] : vps->getCodedScale    ( voiInVps ); 
-  Int* codOffset    = camParaSH ? m_aaiCodedOffset[ 0 ] : vps->getCodedOffset   ( voiInVps ); 
-  Int* invCodScale  = camParaSH ? m_aaiCodedScale [ 1 ] : vps->getInvCodedScale ( voiInVps ); 
-  Int* invCodOffset = camParaSH ? m_aaiCodedOffset[ 1 ] : vps->getInvCodedOffset( voiInVps ); 
+  const IntAry1d codScale     = camParaSH ? m_aaiCodedScale [ 0 ] : vps->getCodedScale    ( voiInVps ); 
+  const IntAry1d codOffset    = camParaSH ? m_aaiCodedOffset[ 0 ] : vps->getCodedOffset   ( voiInVps ); 
+  const IntAry1d invCodScale  = camParaSH ? m_aaiCodedScale [ 1 ] : vps->getInvCodedScale ( voiInVps ); 
+  const IntAry1d invCodOffset = camParaSH ? m_aaiCodedOffset[ 1 ] : vps->getInvCodedOffset( voiInVps ); 
 
 
@@ -4100,10 +3908,10 @@
     }
 #endif
-    for ( Int d = 0; d <= ( ( 1 << g_bitDepthY ) - 1 ); d++ )
+    for ( Int d = 0; d <= ( ( 1 << bitDepthY ) - 1 ); d++ )
     {      
-      Int offset =    ( codOffset  [ iInVoi ] << g_bitDepthY ) + ( ( 1 << log2Div ) >> 1 );         
+      Int offset =    ( codOffset  [ iInVoi ] << bitDepthY ) + ( ( 1 << log2Div ) >> 1 );         
       m_depthToDisparityB[ iInVoi ][ d ] = ( codScale [ iInVoi ] * d + offset ) >> log2Div; 
 
-      Int invOffset = ( invCodOffset[ iInVoi ] << g_bitDepthY ) + ( ( 1 << log2Div ) >> 1 );         
+      Int invOffset = ( invCodOffset[ iInVoi ] << bitDepthY ) + ( ( 1 << log2Div ) >> 1 );         
       m_depthToDisparityF[ iInVoi ][ d ] = ( invCodScale[ iInVoi ] * d + invOffset ) >> log2Div; 
     }
@@ -4114,6 +3922,6 @@
 
 
-#if H_MV
-Void TComSlice::checkCrossLayerBlaFlag()
+#if NH_MV
+Void TComSlice::checkCrossLayerBlaFlag() const
 {
   // cross_layer_bla_flag shall be equal to 0 for pictures with nal_unit_type not equal to IDR_W_RADL or IDR_N_LP or with nuh_layer_id not equal to 0.
@@ -4147,5 +3955,5 @@
 
 
-#if H_3D
+#if NH_3D
 Void TComSlice::init3dToolParameters()
 {
@@ -4154,5 +3962,5 @@
   Bool nRLLG0 =  ( getVPS()->getNumRefListLayers( getLayerId() ) > 0 );     
 
-  TComSps3dExtension* sps3dExt = getSPS()->getSps3dExtension();
+  const TComSps3dExtension* sps3dExt = getSPS()->getSps3dExtension();
 
   m_ivMvPredFlag           = sps3dExt->getIvMvPredFlag         ( depthFlag ) && nRLLG0                       ;                             
@@ -4197,5 +4005,5 @@
 }
 
-Void TComSlice::deriveInCmpPredAndCpAvailFlag()
+Void TComSlice::deriveInCmpPredAndCpAvailFlag( )
 {
   Int numCurCmpLIds = getIsDepth() ? 1 : getNumActiveRefLayerPics(); 
@@ -4248,5 +4056,5 @@
   else 
   {
-    TComSps3dExtension* sps3dExt = getSPS()->getSps3dExtension();
+    const TComSps3dExtension* sps3dExt = getSPS()->getSps3dExtension();
     if( !getIsDepth() )
     {
@@ -4280,9 +4088,8 @@
 #endif
 
-
 /** get scaling matrix from RefMatrixID
- * \param sizeId size index
- * \param Index of input matrix
- * \param Index of reference matrix
+ * \param sizeId    size index
+ * \param listId    index of input matrix
+ * \param refListId index of reference matrix
  */
 Void TComScalingList::processRefMatrix( UInt sizeId, UInt listId , UInt refListId )
@@ -4291,132 +4098,228 @@
 }
 
-/** parse syntax infomation 
- *  \param pchFile syntax infomation
- *  \returns false if successful
- */
+Void TComScalingList::checkPredMode(UInt sizeId, UInt listId)
+{
+  Int predListStep = (sizeId == SCALING_LIST_32x32? (SCALING_LIST_NUM/NUMBER_OF_PREDICTION_MODES) : 1); // if 32x32, skip over chroma entries.
+
+  for(Int predListIdx = (Int)listId ; predListIdx >= 0; predListIdx-=predListStep)
+  {
+    if( !memcmp(getScalingListAddress(sizeId,listId),((listId == predListIdx) ?
+      getScalingListDefaultAddress(sizeId, predListIdx): getScalingListAddress(sizeId, predListIdx)),sizeof(Int)*min(MAX_MATRIX_COEF_NUM,(Int)g_scalingListSize[sizeId])) // check value of matrix
+     && ((sizeId < SCALING_LIST_16x16) || (getScalingListDC(sizeId,listId) == getScalingListDC(sizeId,predListIdx)))) // check DC value
+    {
+      setRefMatrixId(sizeId, listId, predListIdx);
+      setScalingListPredModeFlag(sizeId, listId, false);
+      return;
+    }
+  }
+  setScalingListPredModeFlag(sizeId, listId, true);
+}
+
+static Void outputScalingListHelp(std::ostream &os)
+{
+  os << "The scaling list file specifies all matrices and their DC values; none can be missing,\n"
+         "but their order is arbitrary.\n\n"
+         "The matrices are specified by:\n"
+         "<matrix name><unchecked data>\n"
+         "  <value>,<value>,<value>,....\n\n"
+         "  Line-feeds can be added arbitrarily between values, and the number of values needs to be\n"
+         "  at least the number of entries for the matrix (superfluous entries are ignored).\n"
+         "  The <unchecked data> is text on the same line as the matrix that is not checked\n"
+         "  except to ensure that the matrix name token is unique. It is recommended that it is ' ='\n"
+         "  The values in the matrices are the absolute values (0-255), not the delta values as\n"
+         "  exchanged between the encoder and decoder\n\n"
+         "The DC values (for matrix sizes larger than 8x8) are specified by:\n"
+         "<matrix name>_DC<unchecked data>\n"
+         "  <value>\n";
+
+  os << "The permitted matrix names are:\n";
+  for(UInt sizeIdc = 0; sizeIdc < SCALING_LIST_SIZE_NUM; sizeIdc++)
+  {
+    for(UInt listIdc = 0; listIdc < SCALING_LIST_NUM; listIdc++)
+    {
+      if ((sizeIdc!=SCALING_LIST_32x32) || (listIdc%(SCALING_LIST_NUM/NUMBER_OF_PREDICTION_MODES) == 0))
+      {
+        os << "  " << MatrixType[sizeIdc][listIdc] << '\n';
+      }
+    }
+  }
+}
+
+Void TComScalingList::outputScalingLists(std::ostream &os) const
+{
+  for(UInt sizeIdc = 0; sizeIdc < SCALING_LIST_SIZE_NUM; sizeIdc++)
+  {
+    const UInt size = min(8,4<<(sizeIdc));
+    for(UInt listIdc = 0; listIdc < SCALING_LIST_NUM; listIdc++)
+    {
+      if ((sizeIdc!=SCALING_LIST_32x32) || (listIdc%(SCALING_LIST_NUM/NUMBER_OF_PREDICTION_MODES) == 0))
+      {
+        const Int *src = getScalingListAddress(sizeIdc, listIdc);
+        os << (MatrixType[sizeIdc][listIdc]) << " =\n  ";
+        for(UInt y=0; y<size; y++)
+        {
+          for(UInt x=0; x<size; x++, src++)
+          {
+            os << std::setw(3) << (*src) << ", ";
+          }
+          os << (y+1<size?"\n  ":"\n");
+        }
+        if(sizeIdc > SCALING_LIST_8x8)
+        {
+          os << MatrixType_DC[sizeIdc][listIdc] << " = \n  " << std::setw(3) << getScalingListDC(sizeIdc, listIdc) << "\n";
+        }
+        os << "\n";
+      }
+    }
+  }
+}
+
 Bool TComScalingList::xParseScalingList(Char* pchFile)
 {
-  FILE *fp;
-  Char line[1024];
-  UInt sizeIdc,listIdc;
-  UInt i,size = 0;
-  Int *src=0,data;
-  Char *ret;
-  UInt  retval;
-
-  if((fp = fopen(pchFile,"r")) == (FILE*)NULL)
-  {
-    printf("can't open file %s :: set Default Matrix\n",pchFile);
+  static const Int LINE_SIZE=1024;
+  FILE *fp = NULL;
+  Char line[LINE_SIZE];
+
+  if (pchFile == NULL)
+  {
+    fprintf(stderr, "Error: no scaling list file specified. Help on scaling lists being output\n");
+    outputScalingListHelp(std::cout);
+    std::cout << "\n\nExample scaling list file using default values:\n\n";
+    outputScalingLists(std::cout);
+    exit (1);
     return true;
   }
-
-  for(sizeIdc = 0; sizeIdc < SCALING_LIST_SIZE_NUM; sizeIdc++)
-  {
-    size = min(MAX_MATRIX_COEF_NUM,(Int)g_scalingListSize[sizeIdc]);
-    for(listIdc = 0; listIdc < g_scalingListNum[sizeIdc]; listIdc++)
-    {
-      src = getScalingListAddress(sizeIdc, listIdc);
-
-      fseek(fp,0,0);
-      do 
-      {
-        ret = fgets(line, 1024, fp);
-        if ((ret==NULL)||(strstr(line, MatrixType[sizeIdc][listIdc])==NULL && feof(fp)))
-        {
-          printf("Error: can't read Matrix :: set Default Matrix\n");
-          return true;
-        }
-      }
-      while (strstr(line, MatrixType[sizeIdc][listIdc]) == NULL);
-      for (i=0; i<size; i++)
-      {
-        retval = fscanf(fp, "%d,", &data);
-        if (retval!=1)
-        {
-          printf("Error: can't read Matrix :: set Default Matrix\n");
-          return true;
-        }
-        src[i] = data;
-      }
-      //set DC value for default matrix check
-      setScalingListDC(sizeIdc,listIdc,src[0]);
-
-      if(sizeIdc > SCALING_LIST_8x8)
-      {
-        fseek(fp,0,0);
-        do 
-        {
-          ret = fgets(line, 1024, fp);
-          if ((ret==NULL)||(strstr(line, MatrixType_DC[sizeIdc][listIdc])==NULL && feof(fp)))
+  else if ((fp = fopen(pchFile,"r")) == (FILE*)NULL)
+  {
+    fprintf(stderr, "Error: cannot open scaling list file %s for reading\n",pchFile);
+    return true;
+  }
+
+  for(UInt sizeIdc = 0; sizeIdc < SCALING_LIST_SIZE_NUM; sizeIdc++)
+  {
+    const UInt size = min(MAX_MATRIX_COEF_NUM,(Int)g_scalingListSize[sizeIdc]);
+
+    for(UInt listIdc = 0; listIdc < SCALING_LIST_NUM; listIdc++)
+    {
+      Int * const src = getScalingListAddress(sizeIdc, listIdc);
+
+      if ((sizeIdc==SCALING_LIST_32x32) && (listIdc%(SCALING_LIST_NUM/NUMBER_OF_PREDICTION_MODES) != 0)) // derive chroma32x32 from chroma16x16
+      {
+        const Int *srcNextSmallerSize = getScalingListAddress(sizeIdc-1, listIdc);
+        for(UInt i=0; i<size; i++)
+        {
+          src[i] = srcNextSmallerSize[i];
+        }
+        setScalingListDC(sizeIdc,listIdc,(sizeIdc > SCALING_LIST_8x8) ? getScalingListDC(sizeIdc-1, listIdc) : src[0]);
+      }
+      else
+      {
+        {
+          fseek(fp, 0, SEEK_SET);
+          Bool bFound=false;
+          while ((!feof(fp)) && (!bFound))
           {
-            printf("Error: can't read DC :: set Default Matrix\n");
+            Char *ret = fgets(line, LINE_SIZE, fp);
+            Char *findNamePosition= ret==NULL ? NULL : strstr(line, MatrixType[sizeIdc][listIdc]);
+            // This could be a match against the DC string as well, so verify it isn't
+            if (findNamePosition!= NULL && (MatrixType_DC[sizeIdc][listIdc]==NULL || strstr(line, MatrixType_DC[sizeIdc][listIdc])==NULL))
+            {
+              bFound=true;
+            }
+          }
+          if (!bFound)
+          {
+            fprintf(stderr, "Error: cannot find Matrix %s from scaling list file %s\n", MatrixType[sizeIdc][listIdc], pchFile);
             return true;
           }
         }
-        while (strstr(line, MatrixType_DC[sizeIdc][listIdc]) == NULL);
-        retval = fscanf(fp, "%d,", &data);
-        if (retval!=1)
-        {
-          printf("Error: can't read Matrix :: set Default Matrix\n");
-          return true;
-        }
-        //overwrite DC value when size of matrix is larger than 16x16
-        setScalingListDC(sizeIdc,listIdc,data);
-      }
-    }
-  }
+        for (UInt i=0; i<size; i++)
+        {
+          Int data;
+          if (fscanf(fp, "%d,", &data)!=1)
+          {
+            fprintf(stderr, "Error: cannot read value #%d for Matrix %s from scaling list file %s at file position %ld\n", i, MatrixType[sizeIdc][listIdc], pchFile, ftell(fp));
+            return true;
+          }
+          if (data<0 || data>255)
+          {
+            fprintf(stderr, "Error: QMatrix entry #%d of value %d for Matrix %s from scaling list file %s at file position %ld is out of range (0 to 255)\n", i, data, MatrixType[sizeIdc][listIdc], pchFile, ftell(fp));
+            return true;
+          }
+          src[i] = data;
+        }
+
+        //set DC value for default matrix check
+        setScalingListDC(sizeIdc,listIdc,src[0]);
+
+        if(sizeIdc > SCALING_LIST_8x8)
+        {
+          {
+            fseek(fp, 0, SEEK_SET);
+            Bool bFound=false;
+            while ((!feof(fp)) && (!bFound))
+            {
+              Char *ret = fgets(line, LINE_SIZE, fp);
+              Char *findNamePosition= ret==NULL ? NULL : strstr(line, MatrixType_DC[sizeIdc][listIdc]);
+              if (findNamePosition!= NULL)
+              {
+                // This won't be a match against the non-DC string.
+                bFound=true;
+              }
+            }
+            if (!bFound)
+            {
+              fprintf(stderr, "Error: cannot find DC Matrix %s from scaling list file %s\n", MatrixType_DC[sizeIdc][listIdc], pchFile);
+              return true;
+            }
+          }
+          Int data;
+          if (fscanf(fp, "%d,", &data)!=1)
+          {
+            fprintf(stderr, "Error: cannot read DC %s from scaling list file %s at file position %ld\n", MatrixType_DC[sizeIdc][listIdc], pchFile, ftell(fp));
+            return true;
+          }
+          if (data<0 || data>255)
+          {
+            fprintf(stderr, "Error: DC value %d for Matrix %s from scaling list file %s at file position %ld is out of range (0 to 255)\n", data, MatrixType[sizeIdc][listIdc], pchFile, ftell(fp));
+            return true;
+          }
+          //overwrite DC value when size of matrix is larger than 16x16
+          setScalingListDC(sizeIdc,listIdc,data);
+        }
+      }
+    }
+  }
+//  std::cout << "\n\nRead scaling lists of:\n\n";
+//  outputScalingLists(std::cout);
+
   fclose(fp);
   return false;
 }
 
-#if H_MV
-Void TComScalingList::inferFrom( TComScalingList* srcScLi )
+#if NH_MV
+Void TComScalingList::inferFrom( const TComScalingList& srcScLi )
 {
   for(Int sizeId = 0; sizeId < SCALING_LIST_SIZE_NUM; sizeId++)
   {
-    for(Int listId = 0; listId <  g_scalingListNum[sizeId]; listId++)
-    {
-      setRefMatrixId  (sizeId,listId, srcScLi->getRefMatrixId  (sizeId,listId));
-      setScalingListDC(sizeId,listId, srcScLi->getScalingListDC(sizeId,listId));          
-      ::memcpy(getScalingListAddress(sizeId, listId),srcScLi->getScalingListAddress(sizeId, listId),sizeof(Int)*min(MAX_MATRIX_COEF_NUM,(Int)g_scalingListSize[sizeId]));
-    }
-  }
-}
-#endif
-/** initialization process of quantization matrix array
- */
-Void TComScalingList::init()
-{
-  for(UInt sizeId = 0; sizeId < SCALING_LIST_SIZE_NUM; sizeId++)
-  {
-    for(UInt listId = 0; listId < g_scalingListNum[sizeId]; listId++)
-    {
-      m_scalingListCoef[sizeId][listId] = new Int [min(MAX_MATRIX_COEF_NUM,(Int)g_scalingListSize[sizeId])];
-    }
-  }
-  m_scalingListCoef[SCALING_LIST_32x32][3] = m_scalingListCoef[SCALING_LIST_32x32][1]; // copy address for 32x32
-}
-
-/** destroy quantization matrix array
- */
-Void TComScalingList::destroy()
-{
-  for(UInt sizeId = 0; sizeId < SCALING_LIST_SIZE_NUM; sizeId++)
-  {
-    for(UInt listId = 0; listId < g_scalingListNum[sizeId]; listId++)
-    {
-      if(m_scalingListCoef[sizeId][listId]) delete [] m_scalingListCoef[sizeId][listId];
-    }
-  }
-}
-
-/** get default address of quantization matrix 
+    for(Int listId = 0; listId <  SCALING_LIST_NUM; listId++)
+    {
+      setRefMatrixId  (sizeId,listId, srcScLi.getRefMatrixId  (sizeId,listId));
+      setScalingListDC(sizeId,listId, srcScLi.getScalingListDC(sizeId,listId));          
+      ::memcpy(getScalingListAddress(sizeId, listId),srcScLi.getScalingListAddress(sizeId, listId),sizeof(Int)*min(MAX_MATRIX_COEF_NUM,(Int)g_scalingListSize[sizeId]));
+    }
+  }
+}
+#endif
+
+
+/** get default address of quantization matrix
  * \param sizeId size index
  * \param listId list index
  * \returns pointer of quantization matrix
  */
-Int* TComScalingList::getScalingListDefaultAddress(UInt sizeId, UInt listId)
-{
-  Int *src = 0;
+const Int* TComScalingList::getScalingListDefaultAddress(UInt sizeId, UInt listId)
+{
+  const Int *src = 0;
   switch(sizeId)
   {
@@ -4425,11 +4328,7 @@
       break;
     case SCALING_LIST_8x8:
-      src = (listId<3) ? g_quantIntraDefault8x8 : g_quantInterDefault8x8;
-      break;
     case SCALING_LIST_16x16:
-      src = (listId<3) ? g_quantIntraDefault8x8 : g_quantInterDefault8x8;
-      break;
     case SCALING_LIST_32x32:
-      src = (listId<1) ? g_quantIntraDefault8x8 : g_quantInterDefault8x8;
+      src = (listId < (SCALING_LIST_NUM/NUMBER_OF_PREDICTION_MODES) ) ? g_quantIntraDefault8x8 : g_quantInterDefault8x8;
       break;
     default:
@@ -4443,5 +4342,5 @@
 /** process of default matrix
  * \param sizeId size index
- * \param Index of input matrix
+ * \param listId index of input matrix
  */
 Void TComScalingList::processDefaultMatrix(UInt sizeId, UInt listId)
@@ -4457,5 +4356,5 @@
   for(UInt sizeId = 0; sizeId < SCALING_LIST_SIZE_NUM; sizeId++)
   {
-    for(UInt listId = 0; listId < g_scalingListNum[sizeId]; listId++)
+    for(UInt listId = 0; listId < SCALING_LIST_NUM; listId++)
     {
       //check default matrix?
@@ -4473,14 +4372,12 @@
 , m_ppsMap(MAX_NUM_PPS)
 , m_activeVPSId(-1)
-#if !H_MV
+#if !NH_MV
 , m_activeSPSId(-1)
-, m_activePPSId(-1)
-{
-#else
-{
+#endif
+{
+#if NH_MV  
   for (Int i = 0; i < MAX_NUM_LAYERS; i++ )
-  {
-    m_activeSPSId[ i ] = -1; 
-    m_activePPSId[ i ] = -1; 
+  {    
+    m_activeSPSId[i] = -1; 
   }
 #endif
@@ -4494,39 +4391,41 @@
 //! activate a SPS from a active parameter sets SEI message
 //! \returns true, if activation is successful
-#if H_MV
-Bool ParameterSetManager::activateSPSWithSEI(Int spsId, Int layerId )
+#if NH_MV
+//Bool ParameterSetManager::activateSPSWithSEI(Int spsId, Int layerId )
 #else
-Bool ParameterSetManager::activateSPSWithSEI(Int spsId)
-#endif
-{
-  TComSPS *sps = m_spsMap.getPS(spsId);
-  if (sps)
-  {
-    Int vpsId = sps->getVPSId();
-    if (m_vpsMap.getPS(vpsId))
-    {
-      m_activeVPSId = vpsId;
-#if H_MV
-      m_activeSPSId[ layerId ] = spsId;
+//Bool ParameterSetManager::activateSPSWithSEI(Int spsId)
+#endif
+//{
+//TComSPS *sps = m_spsMap.getPS(spsId);
+//  if (sps)
+//  {
+//    Int vpsId = sps->getVPSId();
+//    TComVPS *vps = m_vpsMap.getPS(vpsId);
+//    if (vps)
+//    {
+#if NH_MV
+//      m_activeVPS = *(vps);
+//      m_activeSPS[ layerId ] = *(sps);
 #else
-      m_activeSPSId = spsId;
-#endif
-      return true;
-    }
-    else
-    {
-      printf("Warning: tried to activate SPS using an Active parameter sets SEI message. Referenced VPS does not exist.");
-    }
-  }
-  else
-  {
-    printf("Warning: tried to activate non-existing SPS using an Active parameter sets SEI message.");
-  }
-  return false;
-}
+//      m_activeVPS = *(vps);
+//      m_activeSPS = *(sps);
+#endif
+//      return true;
+//    }
+//    else
+//    {
+//      printf("Warning: tried to activate SPS using an Active parameter sets SEI message. Referenced VPS does not exist.");
+//    }
+//  }
+//  else
+//  {
+//    printf("Warning: tried to activate non-existing SPS using an Active parameter sets SEI message.");
+//  }
+//  return false;
+//}
 
 //! activate a PPS and depending on isIDR parameter also SPS and VPS
 //! \returns true, if activation is successful
-#if H_MV
+#if NH_MV
 Bool ParameterSetManager::activatePPS(Int ppsId, Bool isIRAP, Int layerId )
 #else
@@ -4538,44 +4437,45 @@
   {
     Int spsId = pps->getSPSId();
-#if H_MV
-    if (!isIRAP && (spsId != m_activeSPSId[ layerId ]))
+#if NH_MV
+    if (!isIRAP && (spsId != m_activeSPSId[ layerId ] ))
 #else
-    if (!isIRAP && (spsId != m_activeSPSId))
-#endif
-    {
-      printf("Warning: tried to activate PPS referring to a inactive SPS at non-IRAP.");
-      return false;
-    }
-
-    TComSPS *sps = m_spsMap.getPS(spsId);
-    if (sps)
-    {
-      Int vpsId = sps->getVPSId();
-      if (!isIRAP && (vpsId != m_activeVPSId))
-      {
-        printf("Warning: tried to activate PPS referring to a inactive VPS at non-IRAP.");
-        return false;
-      }
-      if (m_vpsMap.getPS(vpsId))
-      {
-#if H_MV
-        m_activePPSId[ layerId ] = ppsId;
-        m_activeVPSId = vpsId;
-        m_activeSPSId[ layerId ] = spsId;
+    if (!isIRAP && (spsId != m_activeSPSId ))
+#endif
+    {
+      printf("Warning: tried to activate PPS referring to a inactive SPS at non-IDR.");
+    }
+    else
+    {
+      TComSPS *sps = m_spsMap.getPS(spsId);
+      if (sps)
+      {
+        Int vpsId = sps->getVPSId();
+        if (!isIRAP && (vpsId != m_activeVPSId ))
+        {
+          printf("Warning: tried to activate PPS referring to a inactive VPS at non-IDR.");
+        }
+        else
+        {
+          TComVPS *vps =m_vpsMap.getPS(vpsId);
+          if (vps)
+          {
+            m_activeVPSId = vpsId;
+#if NH_MV
+            m_activeSPSId[layerId] = spsId;
 #else
-        m_activePPSId = ppsId;
-        m_activeVPSId = vpsId;
-        m_activeSPSId = spsId;
-#endif
-        return true;
+            m_activeSPSId = spsId;
+#endif
+            return true;
+          }
+          else
+          {
+            printf("Warning: tried to activate PPS that refers to a non-existing VPS.");
+          }
+        }
       }
       else
       {
-        printf("Warning: tried to activate PPS that refers to a non-existing VPS.");
-      }
-    }
-    else
-    {
-      printf("Warning: tried to activate a PPS that refers to a non-existing SPS.");
+       printf("Warning: tried to activate a PPS that refers to a non-existing SPS.");
+      }
     }
   }
@@ -4584,4 +4484,13 @@
     printf("Warning: tried to activate non-existing PPS.");
   }
+
+  // Failed to activate if reach here.
+#if NH_MV
+  m_activeSPSId[layerId]=-1;
+#else
+  m_activeSPSId=-1;
+#endif
+  m_activeVPSId=-1;
+
   return false;
 }
@@ -4589,12 +4498,15 @@
 ProfileTierLevel::ProfileTierLevel()
   : m_profileSpace    (0)
-  , m_tierFlag        (false)
-  , m_profileIdc      (0)
-  , m_levelIdc        (0)
-, m_progressiveSourceFlag  (false)
-, m_interlacedSourceFlag   (false)
-, m_nonPackedConstraintFlag(false)
-, m_frameOnlyConstraintFlag(false)
-#if H_MV
+  , m_tierFlag        (Level::MAIN)
+  , m_profileIdc      (Profile::NONE)
+  , m_levelIdc        (Level::NONE)
+  , m_progressiveSourceFlag  (false)
+  , m_interlacedSourceFlag   (false)
+  , m_nonPackedConstraintFlag(false)
+  , m_frameOnlyConstraintFlag(false)
+#if NH_MV
+  , m_intraConstraintFlag         ( false )
+  , m_onePictureOnlyConstraintFlag( false )
+  , m_lowerBitRateConstraintFlag  ( false )
   , m_max12bitConstraintFlag      ( false )
   , m_max10bitConstraintFlag      ( false )
@@ -4602,8 +4514,5 @@
   , m_max422chromaConstraintFlag  ( false )
   , m_max420chromaConstraintFlag  ( false )
-  , m_maxMonochromeConstraintFlag ( false )
-  , m_intraConstraintFlag         ( false )
-  , m_onePictureOnlyConstraintFlag( false )
-  , m_lowerBitRateConstraintFlag  ( false )
+  , m_maxMonochromeConstraintFlag ( false )  
   , m_inbldFlag                   ( false )
 #endif
@@ -4612,6 +4521,6 @@
 }
 
-#if H_MV
-Bool ProfileTierLevel::getV2ConstraintsPresentFlag()
+#if NH_MV
+Bool ProfileTierLevel::getV2ConstraintsPresentFlag() const
 {
   return ( 
@@ -4621,5 +4530,5 @@
 }
 
-Bool ProfileTierLevel::getInbldPresentFlag()
+Bool ProfileTierLevel::getInbldPresentFlag() const
 {
   return ( 
@@ -4665,5 +4574,32 @@
 }
 
-#if H_MV
+Void calculateParameterSetChangedFlag(Bool &bChanged, const std::vector<UChar> *pOldData, const std::vector<UChar> &newData)
+{
+  if (!bChanged)
+  {
+    if ((pOldData==0 && pOldData!=0) || (pOldData!=0 && pOldData==0))
+    {
+      bChanged=true;
+    }
+    else if (pOldData!=0 && pOldData!=0)
+    {
+      // compare the two
+      if (pOldData->size() != pOldData->size())
+      {
+        bChanged=true;
+      }
+      else
+      {
+        const UChar *pNewDataArray=&(newData)[0];
+        const UChar *pOldDataArray=&(*pOldData)[0];
+        if (memcmp(pOldDataArray, pNewDataArray, pOldData->size()))
+        {
+          bChanged=true;
+        }
+      }
+    }
+  }
+}
+#if NH_MV
 Void TComPTL::inferGeneralValues(Bool profilePresentFlag, Int k, TComPTL* refPTL)
 {
@@ -4754,16 +4690,31 @@
 
 #endif
+
 //! \}
 
-#if H_MV
-TComVPSVUI::TComVPSVUI()
+#if NH_MV
+Void TComVPSVUI::init( Int numLayerSets, Int maxNumSubLayers, Int maxNumLayers )
 {
   m_crossLayerIrapAlignedFlag = true; 
   m_allLayersIdrAlignedFlag   = false; 
-  m_bitRatePresentVpsFlag = false;
-  m_picRatePresentVpsFlag = false;
-  for ( Int i = 0; i < MAX_VPS_OP_SETS_PLUS1; i++)
-  {    
-    for ( Int j = 0; j < MAX_TLAYER; j++)
+  m_bitRatePresentVpsFlag     = false;
+  m_picRatePresentVpsFlag     = false;
+
+  m_bitRatePresentFlag          .resize(numLayerSets); 
+  m_picRatePresentFlag          .resize(numLayerSets); 
+  m_avgBitRate                  .resize(numLayerSets); 
+  m_maxBitRate                  .resize(numLayerSets); 
+  m_constantPicRateIdc          .resize(numLayerSets); 
+  m_avgPicRate                  .resize(numLayerSets); 
+
+  for ( Int i = 0; i < numLayerSets; i++)
+  { 
+    m_bitRatePresentFlag          [i].resize( maxNumSubLayers); 
+    m_picRatePresentFlag          [i].resize( maxNumSubLayers); 
+    m_avgBitRate                  [i].resize( maxNumSubLayers); 
+    m_maxBitRate                  [i].resize( maxNumSubLayers); 
+    m_constantPicRateIdc          [i].resize( maxNumSubLayers); 
+    m_avgPicRate                  [i].resize( maxNumSubLayers); 
+    for ( Int j = 0; j < maxNumSubLayers; j++)
     {    
       m_bitRatePresentFlag          [i][j] = false;
@@ -4778,7 +4729,17 @@
   m_ilpRestrictedRefLayersFlag = false;
 
-  for ( Int i = 0; i < MAX_NUM_LAYERS; i++)
+  m_tileBoundariesAlignedFlag             .resize( maxNumLayers );
+  m_minSpatialSegmentOffsetPlus1          .resize( maxNumLayers );
+  m_ctuBasedOffsetEnabledFlag             .resize( maxNumLayers );
+  m_minHorizontalCtuOffsetPlus1           .resize( maxNumLayers );
+  m_baseLayerParameterSetCompatibilityFlag.resize( maxNumLayers );
+
+  for ( Int i = 0; i < maxNumLayers; i++)
   {          
-    for ( Int j = 0; j < MAX_NUM_LAYERS; j++)
+    m_tileBoundariesAlignedFlag   [i].resize( maxNumLayers );
+    m_minSpatialSegmentOffsetPlus1[i].resize( maxNumLayers );
+    m_ctuBasedOffsetEnabledFlag   [i].resize( maxNumLayers );
+    m_minHorizontalCtuOffsetPlus1 [i].resize( maxNumLayers );
+    for ( Int j = 0; j < maxNumLayers; j++)
     {    
       m_tileBoundariesAlignedFlag   [i][j] = false;
